import javax.swing.*;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.SocketException;
import java.util.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;


/*GUI*/
public class ServerGUI extends JFrame implements ActionListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ArrayList<boardPanel> pMotes;
	Container cp;
	Server server;
	
	JMenuBar menuBar;
	JMenu menu;
	JMenuItem miStart, miClose;
	
	private JLabel lState;
	
	ServerGUI(Server server){
		super("Monitoritzaci pacients");
		pMotes = new ArrayList<boardPanel>();
		setSize(600,400);
		cp = getContentPane();
		cp.setLayout(new BoxLayout(cp, BoxLayout.Y_AXIS));
		this.server=server;
		setVisible(true);
		
		menuBar = new JMenuBar();

		menu = new JMenu("Servidor");
		menuBar.add(menu);
		
		miStart = new JMenuItem("Arrencar servidor");
		miStart.addActionListener(this);
		menu.add(miStart);
		
		miClose = new JMenuItem("Tancar servidor");
		menu.add(miClose);
		miClose.addActionListener(this);
		
		setJMenuBar(menuBar);
		
		lState = new JLabel("Servidor desconnectat");
		lState.setForeground(Color.BLUE);
		lState.setOpaque(true);
		lState.setFont(new Font("Courier New", Font.BOLD, 15));
		
		add(lState);
		
		addWindowListener(
		       new WindowAdapter() {
		           public void windowClosing(WindowEvent e) {
		             System.exit(0);
		             }
		           }
		         );
	}
	
	public void addPanel(boardPanel panel){
	  cp.add(panel);
	  pMotes.add(panel);
	}
	
	public void removePanel(boardPanel panel){
		  cp.remove(panel);
		  pMotes.remove(panel);
	}
	
	public void setDisposable(String id)
	{
		server.setDisposable(id);
	}
	
	public void setState(boolean state)
	{
		if (state)
			this.lState.setText("Servidor connectat");
		else
			this.lState.setText("Servidor desconnectat");
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		if (arg0.getSource()==miStart)
		{
			try {
				server.start();
				 try {
                     Thread.sleep(10);  // milliseconds
                  } catch (InterruptedException ex) {}
			} catch (SocketException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}	
		else if (arg0.getSource()==miClose)
		{
			server.stop();
		}
	}


}
		
		
