import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;


public class boardPanel extends JPanel implements ActionListener{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JLabel lFreqLabel, lFreqValue, lAlarm, lId, lIdValue, lDiscon, lBatteryLevel;
	private String id;
	private JButton bRemove, bReset;
	ServerGUI sGUI;
	
	public boardPanel(FlowLayout flowLayout, ServerGUI sGUI) {
		this.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		setLayout(null);
		this.sGUI=sGUI;
		
		lId = new JLabel("Placa num "); 
		lIdValue = new JLabel("");  
		lFreqLabel = new JLabel("Freqncia de batecs"); 
		lFreqValue = new JLabel(""); 
		lAlarm = new JLabel("CAIGUDA!!");
		lDiscon = new JLabel("PLACA DESCONNECTADA!!");
		lBatteryLevel = new JLabel("BATERIA BAIXA");
		
		bRemove = new JButton("Elimina");
		bReset = new JButton("Reset");
		
		bRemove.addActionListener(this);
		bReset.addActionListener(this);

		lId.setBounds(250,10, 120, 10); 
		add(lId);
		lIdValue.setBounds(320,10, 120, 10); 
		add(lIdValue);
		
		lFreqLabel.setBounds(50,40, 150, 20);
		add(lFreqLabel);
		lFreqValue.setBounds(180,38, 150, 20);
		lFreqValue.setFont(new Font("Times New Roman", Font.BOLD, 20));
		add(lFreqValue);
		
		lAlarm.setBounds(250,40, 150, 20);
		lAlarm.setForeground(Color.RED);
		lAlarm.setOpaque(true);
		lAlarm.setFont(new Font("Courier New", Font.ITALIC, 25));
		lAlarm.setVisible(false);
		add(lAlarm);
		
		lBatteryLevel.setBounds(350,40, 150, 20);
		lBatteryLevel.setForeground(Color.RED);
		lBatteryLevel.setOpaque(true);
		lBatteryLevel.setFont(new Font("Courier New", Font.ITALIC, 25));
		lBatteryLevel.setVisible(false);
		add(lBatteryLevel);
		
		bReset.setBounds(250,65, 90, 20);
		add(bReset);
		bReset.setEnabled(false);
		
		lDiscon.setBounds(250,90, 300, 20);
		lDiscon.setFont(new Font("Courier New", Font.BOLD, 20));
		lDiscon.setVisible(false);
		add(lDiscon);
		
		bRemove.setBounds(250,115, 90, 20);
		add(bRemove);
		bRemove.setEnabled(false);
		
		setBorder(BorderFactory.createLineBorder(Color.black));

	}
	public void setId(String id)
	{
		this.lIdValue.setText(id);
		this.id = new String(id);
	}
	public void setAlarm(boolean cond)
	{
		this.lAlarm.setVisible(cond);
	}
	public void setBattery(boolean cond)
	{
		this.lBatteryLevel.setVisible(cond);
	}
	public void setlFreqValue(String freq)
	{
		this.lFreqValue.setText(freq);
	}
	public void setlDiscon(boolean cond)
	{
		this.lDiscon.setVisible(true);
	}
	public void setRemove(boolean set)
	{
		this.bRemove.setEnabled(set);
	}
	public void setReset(boolean set)
	{
		this.bReset.setEnabled(set);
	}
	@Override
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource()==bRemove)
		{
			this.sGUI.setDisposable(id);
			this.bRemove.setEnabled(false);
		}	
		else
		{
			this.lAlarm.setVisible(false);	
			this.bReset.setEnabled(false);
		}
	}

}
