/*
 * wifly.h
 *
 *  Created on: 25/08/2013
 *      Author: Xavier Vilajosana
 */

#ifndef WIFLY_H_
#define WIFLY_H_

#define WIFLY_PIN_RST 	22

#define OPEN		 	0
#define WEP128		 	1
#define WPA1		 	2
#define MIX			 	3
#define WPA2		 	4
#define ADHOC		 	6
#define WPE64		 	8

#define NORMAL		 	0
#define COMMAND		 	1

void Lock_Wifly();
void UnLock_Wifly();
void Wifly_Reset();
uint32_t Wifly_Init(uint8_t PortNum, uint32_t Baudrate);
uint32_t Wifly_End(uint8_t PortNum);
uint32_t Wifly_Set(uint8_t PortNum, char *Comand, uint32_t Time);
uint32_t Wifly_Set_OK(uint8_t PortNum, char *Comand, uint32_t Time);
uint32_t Wifly_Set_TT_OK(uint8_t PortNum, char *Comand, char *Value, uint32_t Time);
uint32_t Wifly_Set_TN_OK(uint8_t PortNum, char *Comand, int32_t Num, uint32_t Time);
uint32_t Wifly_Set_Check(uint8_t PortNum, char *Comand, char *Check, uint32_t Time);
uint32_t Wifly_Set_TT_Check(uint8_t PortNum, char *Comand, char *Value, char *Check, uint32_t Time);
uint32_t Wifly_CMD(uint8_t PortNum);
uint32_t Wifly_Connect(uint8_t PortNum, uint32_t Mode, char *ssid, char* Phrase);
uint32_t Wifly_Disconnect(uint8_t PortNum);
uint32_t Wifly_JoinSSID(uint8_t PortNum, char * ssid, char * passwd, uint8_t mode);
uint32_t Wifly_Ping(uint8_t PortNum, char *Address);

//WEEK 4 methods
uint32_t Wifly_TCP(uint8_t PortNum, uint32_t value);
uint32_t Wifly_Web_Send(uint8_t PortNum, char *Host, char *Param, uint32_t Value);
int32_t Wifly_Web_Read(uint8_t PortNum, char *Host, char *Param);
uint32_t Wifly_Open(uint8_t PortNum, char *Address);
uint32_t Wifly_Close(uint8_t PortNum);
char *Wifly_Send_And_Read_Response(uint8_t PortNum,char *Send, uint32_t Time);

/** OPTIONAL METHODS **/
uint32_t Wifly_AutoConnect(uint8_t PortNum, uint32_t Mode, char* Phrase);
uint32_t Wifly_Exit(uint8_t PortNum);
uint32_t Wifly_Save(uint8_t PortNum);
uint32_t Wifly_Reboot(uint8_t PortNum);
uint32_t Wifly_IP(uint8_t PortNum);
uint32_t Wifly_Channel(uint8_t PortNum);
int32_t Wifly_RSSI(uint8_t PortNum);
int32_t Wifly_UpTime(uint8_t PortNum);
uint32_t Wifly_GetPower(uint8_t PortNum);
uint32_t Wifly_SetPower(uint8_t PortNum, uint32_t Value);
uint32_t Wifly_ChangeBR(uint8_t PortNum, int32_t Value);
uint32_t Wifly_GET_Telnet(uint8_t PortNum, char *Host, char *Param);
uint32_t Wifly_GET_Base(uint8_t PortNum, char *Host, char *Param);
uint32_t Wifly_Send_Error(uint32_t Limit, uint32_t Init);
uint32_t Wifly_Read_Error(uint32_t Limit, uint32_t Init);

#endif /* WIFLY_H_ */
