#include "LPC17xx.h"
/* FreeRTOS.org includes. */
#include "FreeRTOS.h"


/*void adcChannel(int ch){
    LPC_ADC->ADCR   |= (1<<ch);
}*/

/**********************************************************************************
 ** Task name:		adcInit()
 **
 ** Description:		initializes ADC
 **
 ** Parameters:			none
 ** Returned value:		none
 **********************************************************************************/

void adcInit(){
   LPC_SC->PCONP |= (1 << 12); //Start ADC

   LPC_SC->PCLKSEL0 |= (1<<24); //ADC clock
   LPC_SC->PCLKSEL0 |= (1<<25);
   LPC_ADC->ADCR |= ( 1 << 8 ); // PCLK scaling

   LPC_PINCON->PINSEL1 |=(1<<16);//p0.24 as AD0.1

   LPC_PINCON->PINSEL3 |=(1<<28);//p1.30 as AD0.4
   LPC_PINCON->PINSEL3 |=(1<<29);//

   LPC_PINCON->PINMODE1 |=(1<<15);  //desactivate pull-up & pull-down
   LPC_ADC->ADCR |=(1<<21); //ADC on
   LPC_ADC->ADCR |=(1<<16); //burst mode
}

/**********************************************************************************
 ** Task name:		adcChannel(int ch)
 **
 ** Description:		sets active ADC channel
 **
 ** Parameters:			int ch		active channel
 ** Returned value:		none
 **********************************************************************************/

void adcChannel(int ch){  //Canal de conversió
    LPC_ADC->ADCR   |= (1<<ch);
}


